pbs_queue_attributes(7B)

NAME
pbs_queue_attributes - Attributes of PBS queues

DESCRIPTION
Queues have the following attributes:

acl_group_enable
    Controls whether group access to the queue obeys the access control list defined in the acl_groups queue attribute.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Boolean
    Python type: bool
    Behavior:

    True
        Group access to the queue is limited according to the group access control list.

    False
        All groups are allowed access.

    Default: False

acl_groups
    List of groups which are allowed or denied access to this queue. The groups in the list are groups on the server host, not submitting hosts. List is evaluated left-to-right; first match in list is used.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: String
    Syntax: "[+|-]<group name>[, ...]"
    Python type: pbs.acl
    Default: No default

acl_host_enable
    Controls whether host access to the queue obeys the access control list defined in the acl_hosts queue attribute.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Boolean
    Python type: bool
    Behavior:

    True
        Host access to the queue is limited according to the host access control list.

    False
        All hosts are allowed access.

    Default: False

acl_hosts
    List of hosts from which jobs may be submitted to this queue. List is evaluated left-to-right; first match in list is used.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: String
    Syntax: "[+|-]<hostname>[, ...]"
    Python type: pbs.acl
    Default: No default

acl_user_enable
    Controls whether user access to the queue obeys the access control list defined in the acl_users queue attribute.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Boolean
    Python type: bool
    Behavior:

    True
        User access to the queue is limited according to the user access control list.

    False
        All users are allowed access.

    Default: False

acl_users
    List of users which are allowed or denied access to this queue. List is evaluated left-to-right; first match in list is used.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: String
    Syntax: "[+|-]<username>[, ...]"
    Python type: pbs.acl
    Default: No default

alt_router
    No longer used.

backfill_depth
    Modifies backfilling behavior for this queue. Sets the number of jobs to be backfilled around in this queue. Overrides backfill_depth server attribute.
    Recommendation: set this to less than 100.
    Applies to execution queues.
    Readable by all; settable by all.
    Format: Integer
    Valid values: Must be >=0
    Behavior:

    >= 0
        PBS backfills around the specified number of jobs.

    Unset
        Backfill depth is set to 1.

    Python type: int
    Default: Unset (backfill depth is 1)

checkpoint_min
    Minimum number of minutes of CPU time or walltime allowed between checkpoints of a job. If a user specifies a time less than this value, this value is used instead. The value given in checkpoint_min is used for both CPU minutes and walltime minutes.
    Applies to execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Integer
    Python type: pbs.duration
    Default: No default

default_chunk
    The list of resources which will be inserted into each chunk of a job's select specification if the corresponding resource is not specified by the user. This provides a means for a site to be sure a given resource is properly accounted for even if not specified by the user.
    Applies to execution queues.
    Readable by all; settable by Operator and Manager.
    Format: String
    Syntax:
    default_chunk.<resource name>=<value>
    [, default_chunk.<resource name>=<value>, ...]

    Python type: pbs.pbs_resource
    Syntax:
    default_chunk["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Default: No default

enabled
    Specifies whether this queue accepts new jobs.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Boolean
    Python type: bool
    Behavior:

    True
        This queue is enabled. This queue accepts new jobs; new jobs can be enqueued.

    False
        This queue does not accept new jobs.

    Default: False (disabled)

from_route_only
    Specifies whether this queue accepts jobs only from routing queues, or from both execution and routing queues.
    Applies to routing and execution queues.
    Readable by all; settable by Manager.
    Format: Boolean
    Python type: bool
    Behavior:

    True
        This queue accepts jobs only from routing queues.

    False
        This queue accepts jobs from both execution and routing queues, as well as directly from submitter.

    Default: False

hasnodes
    Indicates whether vnodes are associated with this queue.
    Applies to execution queues.
    Readable by all; set by PBS.
    Format: Boolean
    Python type: bool
    Behavior:
    When True, there are vnodes associated with this queue.

    Default: False

kill_delay
    The time delay between sending SIGTERM and SIGKILL when a qdel command is issued against a running job.
    Applies to execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Integer
    Units: Seconds
    Python type: pbs.duration
    Valid values: Must be >= 0
    Default: 10 seconds

max_array_size
    The maximum number of subjobs that are allowed in an array job.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Integer
    Python type: int
    Default: No default

max_group_res
    Old limit attribute. Incompatible with new limit attributes. The maximum amount of the specified resource that any single group may consume in a complex.
    Applies to execution queues.
    Readable by all; settable by Operator and Manager.
    Format: String
    Syntax: max_group_res.<resource name>=<value>
    Python type: pbs.pbs_resource
    Syntax:
    max_group_res["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Valid values: Any PBS resource, e.g. "ncpus", "mem", "pmem"
    Example: set server max_group_res.ncpus=6
    Default: No default

max_group_res_soft
    Old limit attribute. Incompatible with new limit attributes. The soft limit on the amount of the specified resource that any single group may consume in a complex. If a group is consuming more than this amount of the specified resource, their jobs are eligible to be preempted by jobs from groups who are not over their soft limit.
    Applies to execution queues.
    Readable by all; settable by Operator and Manager.
    Format: String
    Syntax: max_group_res_soft.<resource name>=<value>
    Python type: pbs.pbs_resource
    Syntax:
    max_group_res_soft["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Valid values: Any PBS resource, e.g. "ncpus", "mem", "pmem"
    Example: set queue workq max_group_res_soft.ncpus=3
    Default: No default

max_group_run
    Old limit attribute. Incompatible with new limit attributes. The maximum number of jobs owned by a group that are allowed to be running from this queue at one time.
    Applies to execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Integer
    Python type: int
    Default: No default

max_group_run_soft
    Old limit attribute. Incompatible with new limit attributes. The maximum number of jobs owned by users in a single group that are allowed to be running from this queue at one time. If a group has more than this number of jobs running, their jobs are eligible to be preempted by jobs from groups who are not over their soft limit.
    Applies to execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Integer
    Python type: int
    Default: No default

max_queuable
    Old limit attribute. Incompatible with new limit attributes. The maximum number of jobs allowed to reside in this queue at any given time.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Integer
    Python type: int
    Default: No default (no limit)

max_queued
    Limit attribute. The maximum number of jobs allowed to be queued in or running from this queue. Can be specified for projects, users, groups, or all. Cannot be used with old limit attributes.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Limit specification. See FORMATS.
    Python type: pbs.pbs_resource
    Syntax:
    max_queued["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Default: No default

max_queued_res
    Limit attribute. The maximum amount of the specified resource allowed to be allocated to jobs queued in or running from this queue. Can be specified for projects, users, groups, or all. Cannot be used with old limit attributes.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Limit specification. See FORMATS.
    Syntax: max_queued_res.<resource name>=<value>
    Python type: pbs.pbs_resource
    Syntax:
    max_queued_res["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Valid values: Any PBS resource, e.g. "ncpus", "mem", "pmem"
    Example: set queue workq max_queued_res.ncpus=4
    Default: No default

max_run
    Limit attribute. The maximum number of jobs allowed to be running from this queue. Can be specified for projects, users, groups, or all. Cannot be used with old limit attributes.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Limit specification. See FORMATS.
    Python type: pbs.pbs_resource
    Syntax:
    max_run["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Default: No default

max_run_res
    Limit attribute. The maximum amount of the specified resource allowed to be allocated to jobs running from this queue. Can be specified for projects, users, groups, or all. Cannot be used with old limit attributes.
    Applies to execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Limit specification. See FORMATS.
    Syntax: max_run_res.<resource name>=<value>
    Python type: pbs.pbs_resource
    Syntax:
    max_run_res["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Valid values: Any PBS resource, e.g. "ncpus", "mem", "pmem"
    Example: set queue workq max_run_res.ncpus=4
    Default: No default

max_run_res_soft
    Limit attribute. Soft limit on the amount of the specified resource allowed to be allocated to jobs running from this queue. Can be specified for projects, users, groups, or all. Cannot be used with old limit attributes.
    Applies to execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Limit specification. See FORMATS.
    Syntax: max_run_res_soft.<resource name>=<value>
    Python type: pbs.pbs_resource
    Syntax:
    max_run_res_soft["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Valid values: Any PBS resource, e.g. "ncpus", "mem", "pmem"
    Example: set queue workq max_run_res_soft.ncpus=2
    Default: No default

max_run_soft
    Limit attribute. Soft limit on the number of jobs allowed to be running from this queue. Can be specified for projects, users, groups, or all. Cannot be used with old limit attributes.
    Applies to execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Limit specification. See FORMATS.
    Python type: pbs.pbs_resource
    Syntax:
    max_run_soft["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Default: No default

max_running
    Old limit attribute. Incompatible with new limit attributes. For an execution queue, this is the largest number of jobs allowed to be running at any given time. For a routing queue, this is the largest number of jobs allowed to be transiting from this queue at any given time.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Integer
    Python type: int
    Default: No default

max_user_res
    Old limit attribute. Incompatible with new limit attributes. The maximum amount of the specified resource that any single user may consume.
    Applies to execution queues.
    Readable by all; settable by Operator and Manager.
    Format: String
    Syntax: max_user_res.<resource name>=<value>
    Python type: pbs.pbs_resource
    Syntax:
    max_user_res["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Valid values: Any PBS resource, e.g. "ncpus", "mem", "pmem"
    Example: set queue workq max_user_res.ncpus=2
    Default: No default

max_user_res_soft
    Old limit attribute. Incompatible with new limit attributes. The soft limit on the amount of the specified resource that any single user may consume. If a user is consuming more than this amount of the specified resource, their jobs are eligible to be preempted by jobs from users who are not over their soft limit.
    Applies to execution queues.
    Readable by all; settable by Operator and Manager.
    Format: String
    Syntax: max_user_res_soft.<resource name>=<value>
    Python type: pbs.pbs_resource
    Syntax:
    max_user_res_soft["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Valid values: Any PBS resource, e.g. "ncpus", "mem", "pmem"
    Example: set queue workq max_user_res_soft.ncpus=2
    Default: No default

max_user_run
    Old limit attribute. Incompatible with new limit attributes. The maximum number of jobs owned by a single user that are allowed to be running from this queue at one time.
    Applies to execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Integer
    Python type: int
    Default: No default

max_user_run_soft
    Old limit attribute. Incompatible with new limit attributes. The soft limit on the number of jobs owned by any single user that are allowed to be running from this queue at one time. If a user has more than this number of jobs running, their jobs are eligible to be preempted by jobs from users who are not over their soft limit.
    Applies to execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Integer
    Python type: int
    Default: No default

node_group_key
    Specifies the resources to use for placement sets. Overrides server's node_group_key attribute. Specified resources must be of type string_array.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: string_array
    Syntax:
    Comma-separated list of resource names.
    When specifying multiple resources, enclose value in double quotes.

    Python type: pbs.node_group_key
    Example:
    Qmgr> set queue workq node_group_key=<resource name>

    Default: No default

partition
    Name of partition to which this queue is assigned. Cannot be set for routing queue. An execution queue cannot be changed to a routing queue while this attribute is set.
    Applies to execution queues.
    Readable by all; settable by Manager.
    Format: String
    Python type: str
    Default: No default

Priority
    The priority of this queue compared to other queues of the same type in this PBS complex. Priority can define a queue as an express queue. See preempt_queue_prio in the pbs_sched(8B) man page. Used for execution queues only; the value of Priority has no meaning for routing queues.
    Applies to execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Integer
    Valid values: -1024 to 1023
    Python type: int
    Default: No default

queued_jobs_threshold
    Limit attribute. The maximum number of jobs allowed to be queued in this queue. Can be specified for projects, users, groups, or all. Cannot be used with old limit attributes.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Limit specification; See LIMITS
    Python type: pbs.pbs_resource
    Syntax:
    queued_jobs_threshold["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Default: No default

queued_jobs_threshold_res
    Limit attribute. The maximum amount of the specified resource allowed to be allocated to jobs queued in this queue. Can be specified for projects, users, groups, or all. Cannot be used with old limit attributes.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: limit specification. See LIMITS
    Syntax: queued_jobs_threshold_res.<resource name>=<value>
    Python type: pbs.pbs_resource
    Syntax:
    queued_jobs_threshold_res_["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Valid values: Any PBS resource, e.g. "ncpus", "mem", "pmem"
    Example: set queue workq queued_jobs_threshold_res.ncpus=8
    Default: No default

queue_type
    The type of the queue. This attribute must be explicitly set at queue creation.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: String
    Python type:
    PBS queue type constant: pbs.QUEUETYPE_EXECUTION or pbs.QUEUETYPE_ROUTE

    Valid values: "e", "execution", "r", "route"
    Default: No default

require_cred
    Specifies the credential type required. All jobs submitted to the named queue without the specified credential will be rejected.
    Not supported under Windows.
    Applies to routing and execution queues.
    Readable by all; settable by Manager.
    Format: String
    Python type: str
    Valid values: krb5 or dce
    Default: Unset

require_cred_enable
    Specifies whether the credential authentication method specified in the require_cred queue attribute is required for this queue.
    Not supported under Windows.
    Applies to routing and execution queues.
    Readable by all; settable by Manager.
    Format: Boolean
    Python type: bool
    Behavior:
    When set to True, the credential authentication method is required.

    Default: False

resources_assigned
    The total for each kind of resource allocated to running and exiting jobs in this queue.
    Applies to execution queues.
    Readable by all; set by PBS.
    Format: String
    Syntax:
    resources_assigned.<resource name>=<value><newline>
    resources_assigned.<resource name>=<value><newline> ...

    Python type: pbs.pbs_resource
    Syntax:
    resources_assigned["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Default value: No default

resources_available
    The list of resources and amounts available to jobs running in this queue. The sum of the resource of each type used by all jobs running from this queue cannot exceed the total amount listed here. See the qmgr(1B) man page.
    Applies to execution queues.
    Readable by all; settable by Operator and Manager.
    Format: String
    Syntax:
    resources_available.<resource name>=<value><newline>
    resources_available.<resource name>=<value><newline> ...

    Python type: pbs.pbs_resource
    Syntax:
    resources_available["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Default value: No default

resources_default
    The list of default resource values which are set as limits for a job residing in this queue and for which the job did not specify a limit. If not explicitly set, the default limit for a job is determined by the first of the following attributes which is set: server's resources_default, queue's resources_max, server's resources_max. If none of these is set, the job gets unlimited resource usage.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: String
    Syntax:
    resources_default.<resource name>=<value>,
    resources_default.<resource name>=<value>, ...

    Python type: pbs.pbs_resource
    Syntax:
    resources_default["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Default value: No default

resources_max
    The maximum amount of each resource that can be requested by a single job in this queue. The queue value supersedes any server wide maximum limit.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: String
    Syntax:
    resources_max.<resource name>=<value>,
    resources_max.<resource name>=<value>, ...

    Python type: pbs.pbs_resource
    Syntax:
    resources_max["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Default value: No default (infinite usage)

resources_min
    The minimum amount of each resource that can be requested by a single job in this queue.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: String
    Syntax:
    resources_min.<resource name>=<value>,
    resources_min.<resource name>=<value>, ...

    Python type: pbs.pbs_resource
    Syntax:
    resources_min["<resource name>"]=<value>
    where resource name is any built-in or custom resource

    Default value: No default (zero usage)

route_destinations
    The list of destinations to which jobs may be routed.
    Must be set to at least one valid destination.
    Applies to routing queues.
    Readable by all; settable by Manager.
    Format: String
    Syntax:
    List of comma-separated strings:
    <queue name>[@<server host>[:<port>]]

    Python type: pbs.route_destinations
    Example: Q1,Q2@remote,Q3@remote:15501
    Default: No default

route_held_jobs
    Specifies whether jobs in the held state can be routed from this queue.
    Applies to routing queues.
    Readable by all; settable by Operator and Manager.
    Format: Boolean
    Python type: bool
    Behavior:
    When True, jobs with a hold can be routed from this queue.

    Default: False

route_lifetime
    The maximum time a job is allowed to reside in this routing queue. If a job cannot be routed in this amount of time, the job is aborted.
    Applies to routing queues.
    Readable by all; settable by Operator and Manager.
    Format: Integer
    Units: Seconds
    Python type: pbs.duration
    Behavior:

    >0  Jobs can reside for specified number of seconds

    0 or unset
        Jobs can reside for infinite time

    Default: Unset

route_retry_time
    Time delay between routing retries. Typically used when the network between servers is down.
    Applies to routing queues.
    Readable by all; settable by Operator and Manager.
    Format: Integer
    Units: Seconds
    Python type: pbs.duration
    Default: 30 seconds

route_waiting_jobs
    Specifies whether jobs whose Execution_Time attribute value is in the future can be routed from this queue.
    Applies to routing queues.
    Readable by all; settable by Operator and Manager.
    Format: Boolean
    Python type: bool Behavior:
    When True, jobs with a future Execution_Time can be routed from this queue.

    Default: False

started
    Specifies whether jobs in this queue can be scheduled for execution.
    Applies to routing and execution queues.
    Readable by all; settable by Operator and Manager.
    Format: Boolean
    Python type: bool
    Behavior: When True, jobs in this queue can run.
    Default: False

state_count
    The total number of jobs in each state currently residing in this queue.
    Applies to routing and execution queues.
    Readable by all; set by PBS.
    Format: String
    Syntax: transiting=<value>,exiting=<value>, ...
    Python type: pbs.state_count
    Default: No default

total_jobs
    The number of jobs currently residing in this queue.
    Applies to routing and execution queues.
    Readable by all; set by PBS.
    Format: Integer
    Python type: int
    Default: No default

FORMATS

Limit specification
    Limit attributes can be set, added to, or removed from. Format for setting a limit specification:
    set server <limit attribute> = "<limit specification>=<limit>[, <limit specification>=<limit>] ..."

    Format for adding to a limit specification:
    set server <limit attribute> += "<limit specification>=<limit>[, <limit specification>=<limit>] ..."

    Format for removing from a limit specification:
    set server <limit attribute> -= "<limit specification>=<limit>[, [<limit specification>=<limit>] ..."
    or
    set server <limit attribute> -= "<limit specification>[, <limit specification>] ..."

    Where limit specification is
    o:PBS_ALL Overall limit
    u:PBS_GENERIC Generic users
    u:<username> A specific user
    g:PBS_GENERIC Generic groups
    g:<group name> A specific group
    p:PBS_GENERIC Generic projects
    p:<project name> A specific project

    The limit specification can contain spaces anywhere except after the colon (":").
    If there are comma-separated limit specifications, the entire string must be enclosed in double quotes.
    A username, groupname, or project name containing spaces must be enclosed in quotes.
    If a username, groupname, or project name is quoted using double quotes, and the entire string requires quotes, the outer enclosing quotes must be single quotes. Similarly, if the inner quotes are single quotes, the outer quotes must be double quotes.
    PBS_ALL is a keyword which indicates that this limit applies to the usage total.
    PBS_GENERIC is a keyword which indicates that this limit applies to generic users, groups, or projects.
    When removing a limit, the limit value does not need to be specified.
    For example, to set the max_queued limit on QueueA to 5 for total usage, and to limit user bill to 3:
    s q QueueA max_queued = "[o:PBS_ALL=5], [u:bill =3]"

    Examples of setting, adding, and removing:
    set server max_run="[u:PBS_GENERIC=2], [g:group1=10], [o:PBS_ALL = 100]"
    set server max_run+="[u:user1=3], [g:PBS_GENERIC=8]"
    set server max_run-="[u:user2], [g:group3]"
    set server max_run_res.ncpus="[u:PBS_GENERIC=2], [g:group1=8], [o:PBS_ALL = 64]"

    See the PBS Professional Administrator's Guide.

Incompatible Limit Attributes
The old and new limit attributes are incompatible. If any of one kind is set, none of the other kind can be set. All of one kind must be unset in order to set any of the other kind.

SEE ALSO
The PBS Professional Administrator's Guide, qmgr(1B)